#include "uPDF.h"

#include <iostream>
#include <sstream>
#include <string>  
#include <fstream>
using namespace std;
/* Common Block Declarations */


extern bool first ;

extern string filename ;

 void uPDF::ccfmuPDF(int kf, double x, double q2, double p, double xpq[13])
{
    /* Initialized data */

    static int na[3] = { 51,51,51 };


    /* Local static variables */
    static double a[153],xa[3];
    static double px[52], xx[52], q2x[52];
    static double f_grid0[132651], f_grid1[132651], f_grid2[132651], f_grid3[132651];
    static double qscal, qg0;
    static int n1min, n1max, n2min, n2max, n3min, n3max, ncall;
    static int iqqbar, iglu, ikincut, ipgg, ns_sel;

    /* Local variables */
    int irr, i, j, k, in, ip;
    int igrid;
    char txt[72], adum[1];
    double rp,rx,rq2;
    double xpd0[140608], xpd1[140608], xpd2[140608], xpd3[140608];
    double dval,uval,glu, sea;
    double rkms0, rkms1, rkms2, rkms3, rkms4, rkms1b, rkms2b, rkms3b, rkms4b;
    double bb, ktqt, qcdlam, scal, qtd1, ktd1;

    /* Parameter adjustments */
    xpq -= -6;

    /* Function Body */
    if (abs(kf) == 2212) {
    } else {
	cout << " ccfmstfu: no valid kf = " << kf << endl;
      cout <<" ccfmstfu: only applicable for proton" << endl;
    }
    if (first) {
	n1min = 0;
	n1max = 0;
	n2min = 0;
	n2max = 0;
	n3min = 0;
	n3max = 0;
	ncall = 0;
	i = 0;
	scal = 1.;
	ipgg = 0;
	ns_sel = -1;


	cout <<  "ccfm_uPDF: read grid from " << filename << endl;
      string text1,text2,text3,text4,textdum;
      const char *testname = filename.c_str();
      cout << testname << endl;
      ifstream myfile (testname);
      if (myfile.is_open()) {
         myfile >> text1 >> textdum >> qg0 >> text2 >>  ikincut ;
         cout << text1 << " " << qg0 << " "<< text2 << " " << ikincut <<endl;
         myfile >> text1 >> textdum >> ipgg >> text2 >> textdum >> ns_sel ;
         cout << text1 << " " << ipgg << " "<< text2 << " " << ns_sel <<endl;
         myfile >> text1 >> textdum >> qcdlam  ;
         cout << text1 << " " << qcdlam <<endl;
         myfile >> text1 >> text2 >> text3>> text4  ;
         cout << text1 << text2 << text3 << text4 << endl;

      }

	for (j = 1; j <= 51; ++j) {
	    for (i = 1; i <= 51; ++i) {
		for (k = 1; k <= 51; ++k) {
                   if (!myfile.eof() ) {
                      myfile >>  rx >> rq2 >> rp >> rkms4b >>rkms3b >> rkms2b >> rkms1b 
                        >> rkms0 >> rkms1 >> rkms2 >> rkms3 >> rkms4 ;
                 
//                    cout << rx << " " << rq2 << " " << rp << " " << rkms0 
//                     << " "  << rkms1 << " " <<rkms2 << endl;
                   } 
		    xx[i] = rx;
		    q2x[j] = rq2;
		    px[k] = rp;
		    xpd0[i + (j + k * 52) * 52] = max(0.,rkms0) * scal;
		    xpd1[i + (j + k * 52) * 52] = max(0.,rkms1) * scal;
		    xpd2[i + (j + k * 52) * 52] = max(0.,rkms2) * scal;
		    xpd3[i + (j + k * 52) * 52] = max(0.,rkms3) * scal;
                
		}
	    }
	}
      cout << " end of file: ccfmstfu at " << j << " " << i << " " << k << endl;
	in = 0;
	for (i = 1; i <= 51; ++i) {
	    ++in;
	    a[in - 1] = q2x[i];
	}
	for (i = 1; i <= 51; ++i) {
	    ++in;
	    a[in - 1] = xx[i];
	}
	for (i = 1; i <= 51; ++i) {
	    ++in;
	    a[in - 1] = px[i];
	}
	for (i = 1; i <= 51; ++i) {
	    for (k = 1; k <= 51; ++k) {
		for (j = 1; j <= 51; ++j) {
		    f_grid0[j + (i + k * 51) * 51 - 2653] = xpd0[i + (j + k * 52) * 52];
		    f_grid1[j + (i + k * 51) * 51 - 2653] = xpd1[i + (j + k * 52) * 52];
		    f_grid2[j + (i + k * 51) * 51 - 2653] = xpd2[i + (j + k * 52) * 52];
		    f_grid3[j + (i + k * 51) * 51 - 2653] = xpd3[i + (j + k * 52) * 52];
//                cout << "fgrid " << i<< " " << j << " " << k << " "<< j + (i + k * 51) * 51 - 2653 << endl; 
/*
                if ( xpd0[i + (j + k * 52) * 52] > 0 ) { 
                cout << f_grid0[j + (i + k * 51) * 51 - 2653] << " " << xpd0[i + (j + k * 52) * 52] << endl; }
*/               
		}
	    }
	}
	first = false;
	cout <<  "  parton densities read from file unit 30 " << endl;
    }
    ++ncall;
    xa[0] = log(q2);
    xa[1] = log(x);
    xa[2] = log(p);
    if (xa[2] < px[1]) {
	++n3min;
	if (n3min < 10) {
/*            write(6,*) ' p out of range ',p,' min p ',exp(px(1)) */
/*            write(6,*) ' p out of range ',xa(3),px(1) */
	} else if (n3min == 10) {
/*            write(6,*) ' p out of range ',p,' min p ',exp(px(1)) */
/*            write(6,*) ' last message printed: min p' */
	}
	xa[2] = px[1];
    }
    if (xa[2] > px[51]) {
	++n3max;
	if (n3max < 10) {
/*            write(6,*) ' p out of range ',p,' max p ',exp(px(n3)) */
	} else if (n3max == 10) {
/*            write(6,*) ' p out of range ',p,' max p ',exp(px(n3)) */
/*            write(6,*) ' last message printed: max p' */
	}
	xa[2] = px[51];
    }
    if (xa[1] >= xx[51]) {
	xa[1] = xx[51] - 1e-4f;
    }
    if (xa[1] < xx[1]) {
	++n2min;
	if (n2min < 10) {
/*            write(6,*) '  x out of range ',x,' min ',exp(xx(1)) */
	} else if (n2min == 10) {
/*            write(6,*) '  x out of range ',x,' min ',exp(xx(1)) */
/*            write(6,*) ' last message printed: min x' */
	}
	xa[1] = xx[1];
    }
    if (xa[0] < q2x[1]) {
	++n1min;
	if (n1min < 10) {
      // cout << "  k2 out of range " << q2 << "  min " << exp(q2x(1)) << endl;
	} else if (n1min == 10) {
      // cout << "  k2 out of range " << q2 << "  min " << exp(q2x(1)) << endl;
      // cout << " last message printed: min k2 " << endl;
	}
	xa[0] = q2x[1];
    }
    if (xa[0] >= q2x[51]) {
	++n1max;
	if (n1max < 10) {
      // cout <<   k2 out of range " << q2 << "  max " << exp(q2x(n1)) << endl;
	} else if (n1max == 10) {
      // cout << "  k2 out of range " << q2 << " max " <<exp(q2x(n1))  << endl;
      // cout << " last message printed: max k2 " <<endl;
	}
	xa[0] = q2x[51] - .1f;
    }
/* check if interpolation or grid wanted */
    igrid = 0;
    if (igrid == 1) {
	if (xa[0] < q2x[1]) {
	   cout << "  k2 out of range " << q2 <<  " min " << exp(q2x[1]) << endl;
	    xa[0] = q2x[1];
	}
	if (xa[0] >= q2x[51]) {
	    cout << "  k2 out of range: x = " << x << "  " << q2x[51] << endl;
	    cout<<  "  k2 out of range " << q2 <<  " max " << exp(q2x[51]) << endl;
	    xa[0] = q2x[51] - .1f;
	}
	i = 0;
L20:
	++i;
	if (xa[0] > a[na[0] - 1]) {
/*       write(6,*) ' q2  ',xa(1),a(na(1)) */
	    cout << " q2 not found " << q2 << endl; 
	    i = na[0];
	} else {
	    if (xa[0] >= a[i - 1] && xa[0] < a[i]) {
	    } else {
		if (i <= na[0]) {
		    goto L20;
		} else {
		    cout <<  " at 20: q2 not found " << q2 << endl;
		}
	    }
	}
	j = 0;
L30:
	++j;
	if (xa[1] >= a[na[0] + j - 1] && xa[1] < a[na[0] + j]) {
	} else {
	    if (j <= na[1]) {
		goto L30;
	    } else {
		cout << " at 30: x not found " << x << endl;
	    }
	}
	k = 0;
L40:
	++k;
	if (xa[2] >= a[na[0] + na[1] + na[2] - 1]) {
	    k = na[2];
	} else {
	    if (xa[2] >= a[na[0] + na[1] + k - 1] && xa[2] < a[na[0] + na[1] 
		    + k]) {
	    } else {
		if (k <= na[2]) {
		    goto L40;
		} else {
		    cout << " at 40: p not found " << p << endl;
		}
	    }
	}
	glu = f_grid0[i + (j + k * 51) * 51 - 2653] / q2;
	uval = f_grid1[i + (j + k * 51) * 51 - 2653] / q2;
	dval = f_grid2[i + (j + k * 51) * 51 - 2653] / q2;

    } else { 
      int c3 = 3;
	glu =  Cdhfint(c3, xa, na, a, f_grid0) / q2;
	uval = Cdhfint(c3, xa, na, a, f_grid1) / q2;
	dval = Cdhfint(c3, xa, na, a, f_grid2) / q2;
	sea  = Cdhfint(c3, xa, na, a, f_grid3) / q2;
    }
    for (ip = -6; ip <= 6; ++ip) {
	xpq[ip] = 0.;
    }
    if (glu > 0.) {
	xpq[0] = glu;
    }
    if (glu > 1e6) {
	cout << " new ccfmstfu x,q2,p,xpq" << x<< " " << q2 << " " << p << " "<< glu<< endl;
	cout << " i,j,k " << i << " " << j << " " << k << endl;
    }
    if (uval > 0.) {
	xpq[1] = uval;
    }
    if (dval > 0.) {
	xpq[2] = dval;
    }
    if (sea > 0.) {
	xpq[3] = sea;
    }
    return ;
} 

